{Peter Cerno, 1. roc., MFF UK, informatika, Bc., skupina 37 (1-Y)}
{Koncovka kral, dama proti kralovi a vezi}
program kqkr;
uses Crt;
const
	set01    : set of Byte = [0, 1];
	set23    : set of Byte = [2, 3];
	set23X   : set of Byte = [2, 3, 255];
	set01234 : set of Byte = [0, 1, 2, 3, 4];
	set0123X : set of Byte = [0, 1, 2, 3, 255];
	Range0    = 0;
	Range1    = 24576;
	Range2    = 31744;
	Range3    = 32640;
	Range4    = 32896;
	Range5    = 1605760;
	Range6    = 2064512;
	Range7    = 2121856;
	Range8    = 2129024;
	Range9    = 2131072;
	RangeKQKX = Range4;
	RangeKQKR = Range9;

var	BasicTable:    array[Byte] of Byte;
	OffsetA:       array[Byte] of Byte;
	OffsetB:       array[Byte] of Byte;
	OffsetC:       array[Byte] of Byte;
	InvOffsetA:    array[Byte] of Byte;
	InvOffsetB:    array[Byte] of Byte;
	InvOffsetC:    array[Byte] of Byte;

	STRATEGY:      array[0..1, 0..RangeKQKR - 1] of Byte;
	STRATEGYCheck: Boolean;
type
	TErrorCode = string[50];
	TState = record
		{white king,  black king,
		 white queen, black rook}
		WK, BK, WQ, BR: Byte;
	end;
	PCell = ^TCell;
	TCell = record
		mState: TState;
		pNext:  PCell;
	end;
	TList = object
		pHead: PCell;
		Count: LongInt;
		procedure Init;
		procedure Free;
		function IsEmpty: Boolean;
		procedure AddState(var State: TState);
		procedure AddList (var List: TList);
		procedure Pop;
	end;
	procedure TList.Init;
	begin
		pHead := nil;
		Count := 0;
	end;
	procedure TList.Free;
	var	pX: PCell;
	begin
		while pHead <> nil do begin
			pX := pHead^.pNext;
			Dispose(pHead);
			pHead := pX;
		end;
		Count := 0;
	end;
	function TList.IsEmpty: Boolean;
	begin
		IsEmpty := pHead = nil;
	end;
	procedure TList.AddState(var State: TState);
	var	pX: PCell;
	begin
		New(pX);
		pX^.mState := State;
		pX^.pNext := pHead;
		pHead := pX;
		Count := Count + 1;
	end;
	procedure TList.AddList(var List: TList);
	var	pX: PCell;
	begin
		pX := List.pHead;
		while pX <> nil do begin
			AddState(pX^.mState);
			pX := pX^.pNext;
		end;
	end;
	procedure TList.Pop;
	var	pX: PCell;
	begin
		pX := pHead;
		if pX <> nil then begin
			pHead := pX^.pNext;
			Dispose(pX);
			Count := Count - 1;
		end;
	end;
var	TmpTable: array[0..7, 0..7] of Byte;
function min(a, b: Integer): Integer;
begin
	if a < b then min := a
	else min := b;
end;
function max(a, b: Integer): Integer;
begin
	if a > b then max := a
	else max := b;
end;
procedure Error(Code: TErrorCode);
begin
	Writeln('Error code: ', Code);
	Halt;
end;
function Row(X: Byte): Byte;
begin
	Row := (X and 15);
end;
function Col(X: Byte): Byte;
begin
	Col := (X and 240) shr 4;
end;
function Add(r, c: Byte): Byte;
begin
	if (r < 8) and (c < 8) then
		Add := c shl 4 + r
	else Add := 255;
end;
procedure InitVariables;
var 	i, j: Byte;
	r, c: Byte;
begin
	Randomize;
	for i := 0 to 255 do begin
		BasicTable[i] := 255;
		OffsetA[i]    := 255;
		OffsetB[i]    := 255;
		OffsetC[i]    := 255;
		InvOffsetA[i] := 255;
		InvOffsetB[i] := 255;
		InvOffsetC[i] := 255;
	end;
	for c := 0 to 7 do
		for r := 0 to 7 do begin
			i := Add(r, c);
			if r = c then begin
				if c < 4 then BasicTable[i] := 2
				else BasicTable[i] := 3;
			end else if r < c then begin
				if c < 4 then BasicTable[i] := 0
				else BasicTable[i] := 1;
			end else BasicTable[i] := 4;
		end;
	i := 0;
	for c := 1 to 7 do
		for r := 0 to c - 1 do begin
			j := Add(r, c);
			OffsetA[j] := i;
			InvOffsetA[i] := j;
			i := i + 1;
		end;
	i := 0;
	for c := 0 to 7 do begin
		r := c;
		j := Add(r, c);
		OffsetB[j] := i;
		InvOffsetB[i] := j;
		i := i + 1;
	end;
	i := 0;
	for c := 0 to 7 do
		for r := 0 to 7 do begin
			j := Add(r, c);
			OffsetC[j] := i;
			InvOffsetC[i] := j;
			i := i + 1;
		end;
	STRATEGYCheck := False;
end;
function Convert(State: TState): LongInt;
var	WK, BK, WQ, BR: Byte;
	nWK, nBK, nWQ, nBR: LongInt;
begin	
	WK := BasicTable[State.WK];
	BK := BasicTable[State.BK];
	WQ := BasicTable[State.WQ];
	BR := BasicTable[State.BR];	
	         if ((WK = 0) and (BK in set01234) and (WQ in set01234) and (BR = 255))       then begin
		nWK := OffsetA[State.WK];
		nBK := OffsetC[State.BK];
		nWQ := OffsetC[State.WQ];
		Convert := nWK + 6 * (nBK + 64 * nWQ) + Range0;
	end else if ((WK = 2) and (BK in set01)    and (WQ in set01234) and (BR = 255))       then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetA[State.BK];
		nWQ := OffsetC[State.WQ];
		Convert := nWK + 4 * (nBK + 28 * nWQ) + Range1;
	end else if ((WK = 2) and (BK in set23)    and (WQ in set01)    and (BR = 255))       then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetB[State.BK];
		nWQ := OffsetA[State.WQ];
		Convert := nWK + 4 * (nBK +  8 * nWQ) + Range2;
	end else if ((WK = 2) and (BK in set23)    and (WQ in set23)    and (BR = 255))       then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetB[State.BK];
		nWQ := OffsetB[State.WQ];
		Convert := nWK + 4 * (nBK +  8 * nWQ) + Range3;
	end else if ((WK = 0) and (BK in set01234) and (WQ in set01234) and (BR in set01234)) then begin
		nWK := OffsetA[State.WK];
		nBK := OffsetC[State.BK];
		nWQ := OffsetC[State.WQ];
		nBR := OffsetC[State.BR];
		Convert := nWK + 6 * (nBK + 64 * (nWQ + 64 * nBR)) + Range4;
	end else if ((WK = 2) and (BK in set01)    and (WQ in set01234) and (BR in set01234)) then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetA[State.BK];
		nWQ := OffsetC[State.WQ];
		nBR := OffsetC[State.BR];
		Convert := nWK + 4 * (nBK + 28 * (nWQ + 64 * nBR)) + Range5;
	end else if ((WK = 2) and (BK in set23)    and (WQ in set01)    and (BR in set01234)) then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetB[State.BK];
		nWQ := OffsetA[State.WQ];
		nBR := OffsetC[State.BR];
		Convert := nWK + 4 * (nBK +  8 * (nWQ + 28 * nBR)) + Range6;
	end else if ((WK = 2) and (BK in set23)    and (WQ in set23)    and (BR in set01))    then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetB[State.BK];
		nWQ := OffsetB[State.WQ];
		nBR := OffsetA[State.BR];
		Convert := nWK + 4 * (nBK +  8 * (nWQ +  8 * nBR)) + Range7;
	end else if ((WK = 2) and (BK in set23)    and (WQ in set23)    and (BR in set23))    then begin
		nWK := OffsetB[State.WK];
		nBK := OffsetB[State.BK];
		nWQ := OffsetB[State.WQ];
		nBR := OffsetB[State.BR];
		Convert := nWK + 4 * (nBK +  8 * (nWQ +  8 * nBR)) + Range8;
	end else Error('Convert() - invalid State');
end;
function InvConvert(Index: LongInt): TState;
var	nWK, nBK, nWQ, nBR: LongInt;
	OutState: TState;
begin
	         if (Index >= Range0) and (Index < Range1) then begin
		Index := Index - Range0;
		nWK := Index mod 6 ; Index := Index div 6 ;
		nBK := Index mod 64; Index := Index div 64;
		nWQ := Index;
		OutState.WK := InvOffsetA[nWK];
		OutState.BK := InvOffsetC[nBK];
		OutState.WQ := InvOffsetC[nWQ];
		OutState.BR := 255;
	end else if (Index >= Range1) and (Index < Range2) then begin
		Index := Index - Range1;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 28; Index := Index div 28;
		nWQ := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetA[nBK];
		OutState.WQ := InvOffsetC[nWQ];
		OutState.BR := 255;
	end else if (Index >= Range2) and (Index < Range3) then begin
		Index := Index - Range2;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 8 ; Index := Index div 8 ;
		nWQ := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetB[nBK];
		OutState.WQ := InvOffsetA[nWQ];
		OutState.BR := 255;
	end else if (Index >= Range3) and (Index < Range4) then begin
		Index := Index - Range3;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 8 ; Index := Index div 8 ;
		nWQ := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetB[nBK];
		OutState.WQ := InvOffsetB[nWQ];
		OutState.BR := 255;
	end else if (Index >= Range4) and (Index < Range5) then begin
		Index := Index - Range4;
		nWK := Index mod 6 ; Index := Index div 6 ;
		nBK := Index mod 64; Index := Index div 64;
		nWQ := Index mod 64; Index := Index div 64;
		nBR := Index;
		OutState.WK := InvOffsetA[nWK];
		OutState.BK := InvOffsetC[nBK];
		OutState.WQ := InvOffsetC[nWQ];
		OutState.BR := InvOffsetC[nBR];
	end else if (Index >= Range5) and (Index < Range6) then begin
		Index := Index - Range5;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 28; Index := Index div 28;
		nWQ := Index mod 64; Index := Index div 64;
		nBR := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetA[nBK];
		OutState.WQ := InvOffsetC[nWQ];
		OutState.BR := InvOffsetC[nBR];
	end else if (Index >= Range6) and (Index < Range7) then begin
		Index := Index - Range6;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 8 ; Index := Index div 8 ;
		nWQ := Index mod 28; Index := Index div 28;
		nBR := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetB[nBK];
		OutState.WQ := InvOffsetA[nWQ];
		OutState.BR := InvOffsetC[nBR];
	end else if (Index >= Range7) and (Index < Range8) then begin
		Index := Index - Range7;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 8 ; Index := Index div 8 ;
		nWQ := Index mod 8 ; Index := Index div 8 ;
		nBR := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetB[nBK];
		OutState.WQ := InvOffsetB[nWQ];
		OutState.BR := InvOffsetA[nBR];
	end else if (Index >= Range8) and (Index < Range9) then begin
		Index := Index - Range8;
		nWK := Index mod 4 ; Index := Index div 4 ;
		nBK := Index mod 8 ; Index := Index div 8 ;
		nWQ := Index mod 8 ; Index := Index div 8 ;
		nBR := Index;
		OutState.WK := InvOffsetB[nWK];
		OutState.BK := InvOffsetB[nBK];
		OutState.WQ := InvOffsetB[nWQ];
		OutState.BR := InvOffsetB[nBR];
	end else Error('InvConvert() - invalid Index');
	InvConvert := OutState;
end;
procedure Sym(var X: Byte; Index: Byte);
var	r, c: Byte;
begin
	if X <> 255 then begin
		r := Row(X);
		c := Col(X);
		case Index of
			0: X := (X xor 112);
			1: X := (r xor 7) shl 4 + (c xor 7);
			2: X := (X xor 7);
			3: X := (r shl 4) + c;
			else Error('Sym() - invalid Index');
		end;
	end;
end;
procedure SymState(var State: TState; Index: Byte);
begin
	if Index < 4 then begin
		Sym(State.WK, Index);
		Sym(State.BK, Index);
		Sym(State.WQ, Index);
		Sym(State.BR, Index);
	end else Error('SymState() - invalid Index');
end;
function IsBasicState(var State: TState): Boolean;
var	WK, BK, WQ, BR: Byte;
begin
	WK := BasicTable[State.WK];
	BK := BasicTable[State.BK];
	WQ := BasicTable[State.WQ];
	BR := BasicTable[State.BR];
	IsBasicState :=
		((WK = 0) and (BK in set01234)) or 
		((WK = 2) and (BK in set01)) or
		((WK = 2) and (BK in set23) and (WQ in set01)) or
		((WK = 2) and (BK in set23) and (WQ in set23X) and (BR in set0123X));
end;
procedure BasicState(var State: TState; var Epsilon: Byte);
var	TestState: TState;
begin
	if IsBasicState(State) then begin
		Epsilon := 0;
		Exit;
	end;
	TestState := State; SymState(TestState, 0);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 1;
		Exit;
	end;
	TestState := State; SymState(TestState, 1);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 2;
		Exit;
	end;
	TestState := State; SymState(TestState, 2);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 3;
		Exit;
	end;
	TestState := State; SymState(TestState, 3);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 4;
		Exit;
	end;
	TestState := State; SymState(TestState, 0); SymState(TestState, 1);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 5;
		Exit;
	end;
	TestState := State; SymState(TestState, 0); SymState(TestState, 2);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 6;
		Exit;
	end;
	TestState := State; SymState(TestState, 0); SymState(TestState, 3);
	if IsBasicState(TestState) then begin
		State := TestState;
		Epsilon := 7;
		Exit;
	end;
end;
procedure OriginalState(var State: TState; Epsilon: Byte);
begin
	case Epsilon of
		0: begin end;
		1: begin SymState(State, 0); end;
		2: begin SymState(State, 1); end;
		3: begin SymState(State, 2); end;
		4: begin SymState(State, 3); end;
		5: begin SymState(State, 1); SymState(State, 0); end;
		6: begin SymState(State, 2); SymState(State, 0); end;
		7: begin SymState(State, 3); SymState(State, 0); end;
		else Error('OriginalState() - invalid Epsilon');
	end;
end;
function WKAttack(X: Byte; State: TState): Boolean;
var	r1, c1: Byte;
	r2, c2: Byte;
begin
	if (State.WK <> 255) and (State.WK <> X) then begin
		r1 := Row(State.WK);
		c1 := Col(State.WK);
		r2 := Row(X);
		c2 := Col(X);
		WKAttack := (abs(r1-r2) <= 1) and (abs(c1-c2) <= 1);
	end else WKAttack := False;
end;
function BKAttack(X: Byte; State: TState): Boolean;
var	r1, c1: Byte;
	r2, c2: Byte;
begin
	if (State.BK <> 255) and (State.BK <> X) then begin
		r1 := Row(State.BK);
		c1 := Col(State.BK);
		r2 := Row(X);
		c2 := Col(X);
		BKAttack := (abs(r1-r2) <= 1) and (abs(c1-c2) <= 1);
	end else BKAttack := False;
end;
function WQAttack(X: Byte; State: TState): Boolean;
var	rWK, cWK: Byte;
	rBK, cBK: Byte;
	rBR, cBR: Byte;
	r0, c0: Byte;
	r1, c1: Byte;
	r2, c2: Byte;
begin
	if (State.WQ <> 255) and (State.WQ <> X) then begin
		r1 := Row(State.WQ);
		c1 := Col(State.WQ);
		r2 := Row(X);
		c2 := Col(X);
		if r1 > r2 then begin
			r0 := r1; r1 := r2; r2 := r0;
			c0 := c1; c1 := c2; c2 := c0;
		end else if (r1 = r2) and (c1 > c2) then begin
			c0 := c1; c1 := c2; c2 := c0;
		end;
		rWK := 8; cWK := 8;
		rBK := 8; cBK := 8;
		rBR := 8; cBR := 8;
		if State.WK <> 255 then begin
			rWK := Row(State.WK);
			cWK := Col(State.WK);
		end;
		if State.BK <> 255 then begin
			rBK := Row(State.BK);
			cBK := Col(State.BK);
		end;
		if State.BR <> 255 then begin
			rBR := Row(State.BR);
			cBR := Col(State.BR);
		end;
		if r1 = r2 then begin
			if ((rWK = r1) and (c1 < cWK) and (cWK < c2)) or
			   ((rBK = r1) and (c1 < cBK) and (cBK < c2)) or
			   ((rBR = r1) and (c1 < cBR) and (cBR < c2)) then
				WQAttack := False
			else WQAttack := True;
		end else if c1 = c2 then begin
			if ((cWK = c1) and (r1 < rWK) and (rWK < r2)) or
			   ((cBK = c1) and (r1 < rBK) and (rBK < r2)) or
			   ((cBR = c1) and (r1 < rBR) and (rBR < r2)) then
				WQAttack := False
			else WQAttack := True;
		end else if r1 + c2 = r2 + c1 then begin
			if ((r1 + cWK = rWK + c1) and (r1 < rWK) and (rWK < r2)) or
			   ((r1 + cBK = rBK + c1) and (r1 < rBK) and (rBK < r2)) or
			   ((r1 + cBR = rBR + c1) and (r1 < rBR) and (rBR < r2)) then
				WQAttack := False
			else WQAttack := True;
		end else if r1 + c1 = r2 + c2 then begin
			if ((r1 + c1 = rWK + cWK) and (r1 < rWK) and (rWK < r2)) or
			   ((r1 + c1 = rBK + cBK) and (r1 < rBK) and (rBK < r2)) or
			   ((r1 + c1 = rBR + cBR) and (r1 < rBR) and (rBR < r2)) then
				WQAttack := False
			else WQAttack := True;
		end else WQAttack := False;
	end else WQAttack := False;
end;
function BRAttack(X: Byte; State: TState): Boolean;
var	rWK, cWK: Byte;
	rBK, cBK: Byte;
	rWQ, cWQ: Byte;
	r0, c0: Byte;
	r1, c1: Byte;
	r2, c2: Byte;
begin
	if (State.BR <> 255) and (State.BR <> X) then begin
		r1 := Row(State.BR);
		c1 := Col(State.BR);
		r2 := Row(X);
		c2 := Col(X);
		if r1 > r2 then begin
			r0 := r1; r1 := r2; r2 := r0;
			c0 := c1; c1 := c2; c2 := c0;
		end else if (r1 = r2) and (c1 > c2) then begin
			c0 := c1; c1 := c2; c2 := c0;
		end;
		rWK := 8; cWK := 8;
		rBK := 8; cBK := 8;
		rWQ := 8; cWQ := 8;
		if State.WK <> 255 then begin
			rWK := Row(State.WK);
			cWK := Col(State.WK);
		end;
		if State.BK <> 255 then begin
			rBK := Row(State.BK);
			cBK := Col(State.BK);
		end;
		if State.WQ <> 255 then begin
			rWQ := Row(State.WQ);
			cWQ := Col(State.WQ);
		end;
		if r1 = r2 then begin
			if ((rWK = r1) and (c1 < cWK) and (cWK < c2)) or
			   ((rBK = r1) and (c1 < cBK) and (cBK < c2)) or
			   ((rWQ = r1) and (c1 < cWQ) and (cWQ < c2)) then
				BRAttack := False
			else BRAttack := True;
		end else if c1 = c2 then begin
			if ((cWK = c1) and (r1 < rWK) and (rWK < r2)) or
			   ((cBK = c1) and (r1 < rBK) and (rBK < r2)) or
			   ((cWQ = c1) and (r1 < rWQ) and (rWQ < r2)) then
				BRAttack := False
			else BRAttack := True;
		end else BRAttack := False;
	end else BRAttack := False;
end;
function IsAttacked(X: Byte; State: TState; Colour: Byte): Boolean;
begin
	case Colour of
		0: IsAttacked := BKAttack(X, State) or BRAttack(X, State);
		1: IsAttacked := WKAttack(X, State) or WQAttack(X, State);
		else Error('IsAttacked() - invalid Colour');
	end;
end;
function IsPseudoLegal(State: TState): Boolean;
begin
	with State do
		if (WK = 255) or (BK = 255) or (WK = BK) then IsPseudoLegal := False
		else begin
			if (WK = WQ) or (WK = BR) or
			   (BK = WQ) or (BK = BR) then IsPseudoLegal := False
			else if (WQ <> 255) and (BR <> 255) and (WQ = BR) then IsPseudoLegal := False
			else IsPseudoLegal := True;
		end;
end;
function IsLegal(State: TState; Colour: Byte): Boolean;
begin
	if IsPseudoLegal(State) then begin
		case Colour of
			0: IsLegal := not IsAttacked(State.WK, State, 0);
			1: IsLegal := not IsAttacked(State.BK, State, 1);
			else Error('IsLegal() - invalid Colour');
		end;
	end else IsLegal := False;
end;
procedure InitTmp(State: TState);
var	r, c: Byte;
begin
	for r := 0 to 7 do
		for c := 0 to 7 do
			TmpTable[r, c] := 0;
	with State do begin
		if WK <> 255 then TmpTable[Row(WK), Col(WK)] := 1 else Error('InitTmp() - illegal State'); {White King}
		if BK <> 255 then TmpTable[Row(BK), Col(BK)] := 2 else Error('InitTmp() - illegal State'); {Black King}
		if WQ <> 255 then TmpTable[Row(WQ), Col(WQ)] := 3; {White Queen}
		if BR <> 255 then TmpTable[Row(BR), Col(BR)] := 4; {Black Rook}
	end;
end;
procedure WKGenerate(var List: TList; State: TState);
var	NewState: TState;
	r, c: Integer;
	i, j: Integer;
begin
	if State.WK = 255 then Error('WKGenerate() - illegal State');
	r := Row(State.WK);
	c := Col(State.WK);
	for i := max(0, r-1) to min(7, r+1) do
		for j := max(0, c-1) to min(7, c+1) do
			if ((i <> r) or (j <> c)) and
			   (TmpTable[i, j] <> 2) and	
			   (TmpTable[i, j] <> 3) then begin
				NewState.WK := Add(i, j);
				NewState.BK := State.BK;
				NewState.WQ := State.WQ;
				if TmpTable[i, j] = 1 then
					Error('WKGenerate() - fatal error')
				else if TmpTable[i, j] = 4 then
					NewState.BR := 255
				else NewState.BR := State.BR;
				List.AddState(NewState);
			end;
end;
procedure BKGenerate(var List: TList; State: TState);
var	NewState: TState;
	r, c: Integer;
	i, j: Integer;
begin
	if State.BK = 255 then Error('BKGenerate() - illegal State');
	r := Row(State.BK);
	c := Col(State.BK);
	for i := max(0, r-1) to min(7, r+1) do
		for j := max(0, c-1) to min(7, c+1) do
			if ((i <> r) or (j <> c)) and
			   (TmpTable[i, j] <> 1) and
			   (TmpTable[i, j] <> 4) then begin
				NewState.WK := State.WK;
				NewState.BK := Add(i, j);
				if TmpTable[i, j] = 2 then
					Error('BKGenerate() - fatal error')
				else if TmpTable[i, j] = 3 then
					NewState.WQ := 255
				else NewState.WQ := State.WQ;
				NewState.BR := State.BR;
				List.AddState(NewState);
			end;
end;
procedure WQGenerate(var List: TList; State: TState);
	function AddState(i, j: Byte): Boolean;
	var	NewState: TState;
	begin
		if (i > 7) or (j > 7) then Error('WQGenerate() - AddState error');
		if TmpTable[i, j] = 1 then AddState := True
		else if TmpTable[i, j] = 2 then AddState := True
		else begin
			NewState.WK := State.WK;
			NewState.BK := State.BK;
			NewState.WQ := Add(i, j);
			if TmpTable[i, j] = 4 then begin
				NewState.BR := 255;
				AddState := True;
			end else begin
				NewState.BR := State.BR;
				AddState := False;
			end;
			List.AddState(NewState);
		end;
	end;
var	r, c: Byte;
	i, j, k: Byte;
begin
	if State.WQ = 255 then Exit;
	r := Row(State.WQ);
	c := Col(State.WQ);
	if r < 7 then for i := r + 1 to 7     do if AddState(i, c) then break;
	if r > 0 then for i := r - 1 downto 0 do if AddState(i, c) then break;
	if c < 7 then for j := c + 1 to 7     do if AddState(r, j) then break;
	if c > 0 then for j := c - 1 downto 0 do if AddState(r, j) then break;
	if (r < 7) and (c < 7) then
		for k := 1 to min(7 - r, 7 - c) do
			if AddState(r + k, c + k) then break;
	if (r > 0) and (c > 0) then
		for k := 1 to min(r, c) do
			if AddState(r - k, c - k) then break;
	if (r < 7) and (c > 0) then
		for k := 1 to min(7 - r, c) do
			if AddState(r + k, c - k) then break;
	if (r > 0) and (c < 7) then
		for k := 1 to min(r, 7 - c) do
			if AddState(r - k, c + k) then break;
end;
procedure BRGenerate(var List: TList; State: TState);
	function AddState(i, j: Byte): Boolean;
	var	NewState: TState;
	begin
		if (i > 7) or (j > 7) then Error('BRGenerate() - AddState error');
		if TmpTable[i, j] = 1 then AddState := True
		else if TmpTable[i, j] = 2 then AddState := True
		else begin
			NewState.WK := State.WK;
			NewState.BK := State.BK;
			if TmpTable[i, j] = 3 then begin
				NewState.WQ := 255;
				AddState := True;
			end else begin
				NewState.WQ := State.WQ;
				AddState := False;
			end;
			NewState.BR := Add(i, j);
			List.AddState(NewState);
		end;
	end;
var	r, c: Byte;
	i, j: Byte;
begin
	if State.BR = 255 then Exit;
	r := Row(State.BR);
	c := Col(State.BR);
	if r < 7 then for i := r + 1 to 7     do if AddState(i, c) then break;
	if r > 0 then for i := r - 1 downto 0 do if AddState(i, c) then break;
	if c < 7 then for j := c + 1 to 7     do if AddState(r, j) then break;
	if c > 0 then for j := c - 1 downto 0 do if AddState(r, j) then break;
end;
procedure Generator(var List: TList; State: TState; Colour: Byte);
var	TmpList: TList;
	pX: PCell;
begin
	InitTmp(State);
	TmpList.Init;
	case Colour of
		0: begin BKGenerate(TmpList, State); BRGenerate(TmpList, State); end;
		1: begin WKGenerate(TmpList, State); WQGenerate(TmpList, State); end;
		else Error('Generator() - invalid Colour');
	end;
	pX := TmpList.pHead;
	while pX <> nil do begin
		if IsLegal(pX^.mState, 1 - Colour) then
			List.AddState(pX^.mState);
		pX := pX^.pNext;
	end;
	TmpList.Free;
end;
procedure PseudoGenerator(var List: TList; State: TState; Colour: Byte);
var	TmpList: TList;
	BKList : TList;
	BRList : TList;
	WKList : TList;
	WQList : TList;
	NewState: TState;
	pX: PCell;
begin
	InitTmp(State);
	TmpList.Init;
	case Colour of
		0: begin
			BKList.Init;
			BRList.Init;
			BKGenerate(BKList, State);
			BRGenerate(BRList, State);
			if State.WQ = 255 then begin
				pX := BKList.pHead;
				while pX <> nil do begin
					NewState := pX^.mState;
					NewState.WQ := State.BK;
					BKList.AddState(NewState);
					pX := pX^.pNext;
				end;
				pX := BRList.pHead;
				while pX <> nil do begin
					NewState := pX^.mState;
					NewState.WQ := State.BR;
					BRList.AddState(NewState);
					pX := pX^.pNext;
				end;
			end;
			TmpList.AddList(BKList);
			TmpList.AddList(BRList);
			BKList.Free;
			BRList.Free;
		   end;
		1: begin
			WKList.Init;
			WQList.Init;
			WKGenerate(WKList, State);
			WQGenerate(WQList, State);
			if State.BR = 255 then begin
				pX := WKList.pHead;
				while pX <> nil do begin
					NewState := pX^.mState;
					NewState.BR := State.WK;
					WKList.AddState(NewState);
					pX := pX^.pNext;
				end;
				pX := WQList.pHead;
				while pX <> nil do begin
					NewState := pX^.mState;
					NewState.BR := State.WQ;
					WQList.AddState(NewState);
					pX := pX^.pNext;
				end;
			end;
			TmpList.AddList(WKList);
			TmpList.AddList(WQList);
			WKList.Free;
			WQList.Free;
		   end;
		else Error('PseudoGenerator() - invalid Colour');
	end;
	pX := TmpList.pHead;
	while pX <> nil do begin
		if IsLegal(pX^.mState, Colour) then
			List.AddState(pX^.mState);
		pX := pX^.pNext;
	end;
	TmpList.Free;
end;
function GetIndex(State: TState): LongInt;
var	Epsilon: Byte;
begin
	BasicState(State, Epsilon);
	GetIndex := Convert(State);
end;
function GetSTRATEGYValue(State: TState; Colour: Byte): Byte;
var	Index: LongInt;
begin
	if (Colour <> 0) and (Colour <> 1) then
		Error('GetIndexValue() - illegal Colour');
	if (STRATEGYCheck) and
	   (IsPseudoLegal(State)) and
	   (State.WK <> 255) and
	   (State.BK <> 255) and
	   (State.WQ <> 255) then begin
		Index := GetIndex(State);
		GetSTRATEGYValue := STRATEGY[Colour, Index];
	end else GetSTRATEGYValue := 255;
end;
function IsLegalMove(FromState, ToState: TState): Boolean;
var	Colour: Byte;
	List  : TList;
	pX    : PCell;
begin
	IsLegalMove := False;
	Colour := 255;
	if (FromState.WK <> ToState.WK) and (ToState.WK <> 255) then Colour := 1;
	if (FromState.BK <> ToState.BK) and (ToState.BK <> 255) then begin if Colour = 255 then Colour := 0 else Exit; end;
	if (FromState.WQ <> ToState.WQ) and (ToState.WQ <> 255) then begin if Colour = 255 then Colour := 1 else Exit; end;
	if (FromState.BR <> ToState.BR) and (ToState.BR <> 255) then begin if Colour = 255 then Colour := 0 else Exit; end;
	if (Colour <> 255) and (IsLegal(FromState, Colour)) then begin
		IsLegalMove := False;
		List.Init;
		Generator(List, FromState, Colour);
		pX := List.pHead;
		while pX <> nil do begin
			if (pX^.mState.WK = ToState.WK) and 
			   (pX^.mState.BK = ToState.BK) and
			   (pX^.mState.WQ = ToState.WQ) and
			   (pX^.mState.BR = ToState.BR) then begin
				IsLegalMove := True;
				break;
			end;
			pX := pX^.pNext;
		end;
		List.Free;
	end else IsLegalMove := False;
end;
function MoveToStr(FromState, ToState: TState): string[10];
	function PosToStr(X: Byte): string[2];
	var	r, c: Byte;
	begin
		if X = 255 then
			Error('MoveToStr() - invalid X');
		r := Row(X);
		c := Col(X);
		PosToStr := Chr(c + Ord('a')) + Chr(r + Ord('1'));
	end;
var	i1, i2: Byte;
	CH: Char;
begin
	if not IsLegalMove(FromState, ToState) then
		Error('MoveToStr() - illegal move');
	if      (FromState.WK <> ToState.WK) and (ToState.WK <> 255) then begin CH := 'K'; i1 := FromState.WK; i2 := ToState.WK; end
	else if (FromState.BK <> ToState.BK) and (ToState.BK <> 255) then begin CH := 'K'; i1 := FromState.BK; i2 := ToState.BK; end
	else if (FromState.WQ <> ToState.WQ) and (ToState.WQ <> 255) then begin CH := 'Q'; i1 := FromState.WQ; i2 := ToState.WQ; end
	else if (FromState.BR <> ToState.BR) and (ToState.BR <> 255) then begin CH := 'R'; i1 := FromState.BR; i2 := ToState.BR; end;
	MoveToStr := CH + PosToStr(i1) + PosToStr(i2);
end;
function StrToMove(var ToState: TState; FromState: TState; Colour: Byte; var S: string[50]): Boolean;
var	r, c   : Integer;
	i1, i2 : Byte;
begin
	ToState := FromState;
	if (Colour <> 0) and (Colour <> 1) then
		Error('StrToMove() - invalid Colour');
	if Length(S) = 4 then begin
		c := Ord(UpCase(S[1])) - Ord('A');
		r := Ord(S[2]) - Ord('1');
		if (r >= 0) and (r <= 7) and
		   (c >= 0) and (c <= 7) then
			i1 := Add(r, c)
		else i1 := 255;
		c := Ord(UpCase(S[3])) - Ord('A');
		r := Ord(S[4]) - Ord('1');
		if (r >= 0) and (r <= 7) and
		   (c >= 0) and (c <= 7) then
			i2 := Add(r, c)
		else i2 := 255;	
		if (i1 = 255) or (i2 = 255) then
			StrToMove := False
		else begin
			StrToMove := False;
			if      FromState.WK = i1 then begin if Colour = 1 then ToState.WK := i2 else Exit; end
			else if FromState.BK = i1 then begin if Colour = 0 then ToState.BK := i2 else Exit; end 
			else if FromState.WQ = i1 then begin if Colour = 1 then ToState.WQ := i2 else Exit; end 
			else if FromState.BR = i1 then begin if Colour = 0 then ToState.BR := i2 else Exit; end;
			if Colour = 0 then begin
				if ToState.WK = i2 then ToState.WK := 255;
				if ToState.WQ = i2 then ToState.WQ := 255;
			end else begin
				if ToState.BK = i2 then ToState.BK := 255;
				if ToState.BR = i2 then ToState.BR := 255;
			end;
			StrToMove := IsLegalMove(FromState, ToState);
		end;
	end else if Length(S) = 3 then begin
		if      UpCase(S[1]) = 'K' then i1 := 1
		else if UpCase(S[1]) = 'Q' then i1 := 2
		else if UpCase(S[1]) = 'R' then i1 := 3
		else i1 := 255;
		c := Ord(UpCase(S[2])) - Ord('A');
		r := Ord(S[3]) - Ord('1');
		if (r >= 0) and (r <= 7) and
		   (c >= 0) and (c <= 7) then
			i2 := Add(r, c)
		else i2 := 255;
		if (i1 = 255) or (i2 = 255) then
			StrToMove := False
		else begin
			StrToMove := False;
			if      i1 = 1 then begin if Colour = 1 then ToState.WK := i2 else ToState.BK := i2; end
			else if	i1 = 2 then begin if Colour = 1 then ToState.WQ := i2 else Exit; end
			else if i1 = 3 then begin if Colour = 0 then ToState.BR := i2 else Exit; end;
			if Colour = 0 then begin
				if ToState.WK = i2 then ToState.WK := 255;
				if ToState.WQ = i2 then ToState.WQ := 255;
			end else begin
				if ToState.BK = i2 then ToState.BK := 255;
				if ToState.BR = i2 then ToState.BR := 255;
			end;
			StrToMove := IsLegalMove(FromState, ToState);
		end;
	end else StrToMove := False;
end;
procedure OptimalMove(var List: TList; var State: TState; Colour: Byte);
var	Index, Yndex: LongInt;
	Value, Ualue: Byte;
	TmpList: TList;
	pX: PCell;
	Check: Boolean;
begin
	if (Colour <> 0) and (Colour <> 1) then
		Error('OptimalMove() - invalid Colour');
	if (IsLegal(State, Colour)) and
	   (State.WQ <> 255) then begin
		Index := GetIndex(State);
		Value := STRATEGY[Colour, Index];
		if Value < 255 then begin
			TmpList.Init;
			Generator(TmpList, State, Colour);
			pX := TmpList.pHead;
			if (Colour = 0) and (Value >= 2) then begin
				Check := False;
				while pX <> nil do begin
					Yndex := GetIndex(pX^.mState);
					Ualue := STRATEGY[1 - Colour, Yndex];
					if Ualue > Value then Error('OptimalMove() - STRATEGY error');
					if Ualue = Value - 1 then begin 
						List.AddState(pX^.mState);
						Check := True;
					end;
					pX := pX^.pNext;
				end;
				if not Check then Error('OptimalMove() - STRATEGY error');
			end else if (Colour = 1) then begin
				Check := False;
				while pX <> nil do begin
					Yndex := GetIndex(pX^.mState);
					Ualue := STRATEGY[1 - Colour, Yndex];
					if Ualue < Value - 1 then Error('OptimalMove() - STRATEGY error');
					if Ualue = Value - 1 then begin
						List.AddState(pX^.mState);
						Check := True;
					end;
					pX := pX^.pNext;
				end;
				if not Check then Error('OptimalMove() - STRATEGY error');
			end;
			TmpList.Free;
		end;
	end;
end;
function FileExist(name: string): Boolean;
var	fInput: file;
	Check : Boolean;
begin
	{$I-}
	Assign(fInput, name);
	Reset(fInput);
	Check := (ioresult = 0);
	{$I+}
	if Check then Close(fInput);
	FileExist := Check
end;
function SaveSTRATEGY: Boolean;
var	Index: LongInt;
	CountMax: LongInt;
	fOutput: file of Byte;
	Check: Boolean;
begin
	{$I-}
	Assign(fOutput, 'strategy.dat');
	Rewrite(fOutput);
	Check := (ioresult = 0);
	{$I+}
	if Check then begin
		CountMax := RangeKQKR div 32;
		for Index := 0 to RangeKQKR - 1 do begin
			if Index mod CountMax = 0 then Write('.');
			Write(fOutput, STRATEGY[0, Index]);
			Write(fOutput, STRATEGY[1, Index]);
		end;
		Close(fOutput);
	end;
	SaveSTRATEGY := Check;
end;
function LoadSTRATEGY: Boolean;
var	Index: LongInt;
	CountMax: LongInt;
	fInput: file of Byte;
	Check: Boolean;
begin
	{$I-}
	Assign(fInput, 'strategy.dat');
	Reset(fInput);
	Check := (ioresult = 0);
	{$I+}
	if Check then begin
		CountMax := RangeKQKR div 32;
		for Index := 0 to RangeKQKR - 1 do begin
			if Index mod CountMax = 0 then Write('.');
			Read(fInput, STRATEGY[0, Index]);
			Read(fInput, STRATEGY[1, Index]);
		end;
		Close(fInput);
		STRATEGYCheck := True;
	end;
	LoadSTRATEGY := Check;
end;
procedure STRATEGYGenerator;
	procedure Analyzer(Left, Right: LongInt);
	var	Index: LongInt;
		Yndex: LongInt;
		List: TList;
		Lyst: TList;
		PseudoState: TState;
		pX, pY: PCell;
		Step : Byte;
		Check: Byte;
		Updated: Boolean;

		CountBlack: LongInt;
		CountWhite: LongInt;
		
		Counter   : LongInt;
		CountMax  : LongInt;
	begin
		Writeln('step 0: black checkmate positions');
		Write  ('working: ');
		CountBlack := 0;
		Counter    := 0;
		CountMax   := (Right - Left + 1) div 32;
		List.Init;
		for Index := Left to Right do begin
			if Counter = CountMax then Counter := 0;
			if Counter = 0 then Write('.');
			Counter := Counter + 1;	
			PseudoState := InvConvert(Index);
			if IsLegal(PseudoState, 0) and
			   IsAttacked(PseudoState.BK, PseudoState, 1) then begin
				Lyst.Init;
				Generator(Lyst, PseudoState, 0);
				if Lyst.IsEmpty then begin
					STRATEGY[0, Index] := 0;
					List.AddState(PseudoState);
					CountBlack := CountBlack + 1;
				end;
				Lyst.Free;
			end;
		end;
		Writeln(' done');
		Writeln('found ', CountBlack, ' black checkmate positions');
		Writeln('step 1: white positions');
		Write  ('working: ');
		CountWhite := 0;
		Counter    := 0;
		CountMax   := (CountBlack + 31) div 32;
		pX := List.pHead;
		while pX <> nil do begin
			if Counter = CountMax then Counter := 0;
			if Counter = 0 then Write('.');
			Counter := Counter + 1;
			Lyst.Init;
			PseudoGenerator(Lyst, pX^.mState, 1);
			pY := Lyst.pHead;
			while pY <> nil do begin
				Yndex := GetIndex(pY^.mState);
				if STRATEGY[1, Yndex] > 1 then begin
					STRATEGY[1, Yndex] := 1;
					CountWhite := CountWhite + 1;
				end;
				pY := pY^.pNext;
			end;
			Lyst.Free;
			pX := pX^.pNext;
		end;
		List.Free;
		Writeln(' done');
		Writeln('found ', CountWhite, ' white positions');
		Step := 2;
		repeat
			Writeln('step ', Step, ': black positions');
			Write  ('working: ');
			CountBlack := 0;
			Counter    := 0;
			CountMax   := (Right - Left + 1) div 32;
			Updated := False;
			List.Init;
			for Index := Left to Right do begin
				if Counter = CountMax then Counter := 0;
				if Counter = 0 then Write('.');
				Counter := Counter + 1;
				if STRATEGY[0, Index] >= 4 then begin
					PseudoState := InvConvert(Index);
					if IsLegal(PseudoState, 0) then begin
						Lyst.Init;
						Generator(Lyst, PseudoState, 0);
						pY := Lyst.pHead;
						if pY = nil then Check := 255
						else begin
							Check := 1;
							while pY <> nil do begin
								if pY^.mState.WQ = 255 then begin
									Check := 255;
									break;
								end else begin
									Yndex := GetIndex(pY^.mState);
									if STRATEGY[1, Yndex] = 255 then begin
										Check := 255;
										break;
									end else if STRATEGY[1, Yndex] > Check then
										Check := STRATEGY[1, Yndex];
								end;
								pY := pY^.pNext;
							end;
						end;
						Lyst.Free;
						if (Check < 255) and (STRATEGY[0, Index] > Check + 1) then begin
							STRATEGY[0, Index] := Check + 1;
							Updated := True;
							List.AddState(PseudoState);
							CountBlack := CountBlack + 1;
						end;
					end;
				end;
			end;
			Writeln(' done');
			Writeln('found ', CountBlack, ' black positions');
			Step := Step + 1;
			Writeln('step ', Step, ': white positions');
			Write  ('working: ');
			CountWhite := 0;
			Counter    := 0;
			CountMax   := (CountBlack + 31) div 32;
			pX := List.pHead;
			while pX <> nil do begin
				if Counter = CountMax then Counter := 0;
				if Counter = 0 then Write('.');
				Counter := Counter + 1;
				Index := GetIndex(pX^.mState);
				Check := STRATEGY[0, Index];
				Lyst.Init;
				PseudoGenerator(Lyst, pX^.mState, 1);
				pY := Lyst.pHead;
				while pY <> nil do begin
					Yndex := GetIndex(pY^.mState);
					if STRATEGY[1, Yndex] > Check + 1 then begin
						STRATEGY[1, Yndex] := Check + 1;
						Updated := True;
						CountWhite := CountWhite + 1;
					end;
					pY := pY^.pNext;
				end;
				Lyst.Free;
				pX := pX^.pNext;
			end;
			List.Free;
			Writeln(' done');
			Writeln('found ', CountWhite, ' white positions');
			Step := Step + 1;
		until not Updated;
	end;
var	Index   : LongInt;
begin
	Writeln;
	Writeln('strategy generator');
	for Index := 0 to RangeKQKR - 1 do begin
		STRATEGY[0, Index] := 255;
		STRATEGY[1, Index] := 255;
	end;
	Writeln('generating strategy for KQ + K: '); Analyzer(0        , RangeKQKX - 1);
	Writeln('generating strategy for KQ + KR:'); Analyzer(RangeKQKX, RangeKQKR - 1);
	STRATEGYCheck := True;
	Write('saving to strategy.dat: ');
	if SaveSTRATEGY then 
		Writeln(' success')
	else	Writeln(' saving failed');
end;
procedure PrintStatePosition(State: TState);
begin	
	if State.WK <> 255 then Write(Chr(Col(State.WK) + Ord('a')), Row(State.WK) + 1) else Write('00');
	if State.BK <> 255 then Write(Chr(Col(State.BK) + Ord('a')), Row(State.BK) + 1) else Write('00');
	if State.WQ <> 255 then Write(Chr(Col(State.WQ) + Ord('a')), Row(State.WQ) + 1) else Write('00');
	if State.BR <> 255 then Write(Chr(Col(State.BR) + Ord('a')), Row(State.BR) + 1) else Write('00');
end;
procedure PrintState(State: TState; X0, Y0: Byte; DEBUG: Byte);
	procedure SetXY(r, c: Byte);
	begin
		GotoXY(X0 + 3*c + 1, Y0 + 7-r);
	end;
	procedure SetX0(c: Byte);
	begin
		GotoXY(X0 + 3*c + 2, Y0 + 8);
	end;
	procedure SetY0(r: Byte);
	begin
		GotoXY(X0, Y0 + 7-r);
	end;
	procedure SetTextBackground(r, c: Byte);
	var	Colour1, Colour2: Byte;
	begin
		Colour1 := 1;
		Colour2 := 2;
		if ((DEBUG = 0) or (DEBUG = 1)) and 
		   IsAttacked(Add(r, c), State, DEBUG) then begin
			Colour1 := 4;
			Colour2 := 4;
		end;
		if (r + c) mod 2 = 0 then TextBackground(Colour1)
		else TextBackground(Colour2);
	end;
	procedure PrintToPos(X: Byte; Ch: Char);
	var	r, c: Byte;
	begin
		if X <> 255 then begin
			r := Row(X);
			c := Col(X);
			SetXY(r, c);
			SetTextBackground(r, c);
			Write(' ', ch, ' ');
		end;
	end;
var	r, c: Byte;
begin
	if (X0 = 0) or (Y0 = 0) then
		Error('PrintState() - invalid position');
	for r := 0 to 7 do
		for c := 0 to 7 do begin
			SetXY(r, c);
			SetTextBackground(r, c);
			Write('   ');
		end;
	with State do begin
		TextColor(15);
		PrintToPos(WK, 'K');
		PrintToPos(WQ, 'Q');
		TextColor(0);
		PrintToPos(BK, 'K');
		PrintToPos(BR, 'R');
	end;
	
	TextBackground(0);
	TextColor(15);
	for r := 0 to 7 do begin
		SetY0(r);
		Write(Chr(r + Ord('1')));
	end;
	for c := 0 to 7 do begin
		SetX0(c);
		Write(Chr(c + Ord('A')));
	end;
	Writeln;
	
	TextBackground(0);
	TextColor(7);
end;
procedure Tester;
const	BlankLine: string = '                                                                      ';
var	State: TState;
	procedure RunParser;
	var	OldState: TState;
		S: string[50];
		r, c: Integer;
	begin
		OldState := State;
		GotoXY(1, 10);
		Write('set WKBKWQBR: ');
		Readln(S);
		if Length(S) < 8 then
			S := S + '        ';
		if S[1] <> ' ' then begin
			c := Ord(UpCase(S[1])) - Ord('A');
			r := Ord(S[2]) - Ord('1');
			if (r >= 0) and (r <= 7) and
			   (c >= 0) and (c <= 7) then
			   State.WK := Add(r, c)
			else State.WK := 255;
		end;
		if S[3] <> ' ' then begin
			c := Ord(UpCase(S[3])) - Ord('A');
			r := Ord(S[4]) - Ord('1');
			if (r >= 0) and (r <= 7) and
			   (c >= 0) and (c <= 7) then
			   State.BK := Add(r, c)
			else State.BK := 255;
		end;
		if S[5] <> ' ' then begin
			c := Ord(UpCase(S[5])) - Ord('A');
			r := Ord(S[6]) - Ord('1');
			if (r >= 0) and (r <= 7) and
			   (c >= 0) and (c <= 7) then
			   State.WQ := Add(r, c)
			else State.WQ := 255;
		end;
		if S[7] <> ' ' then begin
			c := Ord(UpCase(S[7])) - Ord('A');
			r := Ord(S[8]) - Ord('1');
			if (r >= 0) and (r <= 7) and
			   (c >= 0) and (c <= 7) then
			   State.BR := Add(r, c)
			else State.BR := 255;
		end;
		if not IsPseudoLegal(State) then begin
			GotoXY(1, 11); Write('illegal position');
			State := OldState;
			ReadKey;
		end;
		GotoXY(1, 10); Write(BlankLine);
		GotoXY(1, 11); Write(BlankLine);
		GotoXY(1, 10);
	end;
	procedure RunAnalyzer(Colour: Byte);
	var	King: array[0..1] of Byte;
		Name: array[0..1] of string[5];
		List: TList;
		Counter: LongInt;
		pX:      PCell;
		CH:      Char;
	begin
		GotoXY(1, 10);
		if not IsPseudoLegal(State) then begin
			Writeln('illegal position');
			Writeln('press any key to continue');
		end else begin
			King[0] := State.BK; Name[0] := 'black';
			King[1] := State.WK; Name[1] := 'white';
			PrintState(State, 1, 1, Colour);
			Writeln(Name[Colour], ' on move');
			if not IsLegal(State, Colour) then
				Writeln('illegal position for ', Name[Colour])
			else begin
				List.Init;
				Generator(List, State, Colour);
				if List.IsEmpty then begin
					if IsAttacked(King[Colour], State, 1 - Colour) then
						Writeln('checkmate')
					else	Writeln('stalemate');
				end else begin
					if IsAttacked(King[Colour], State, 1 - Colour) then
						Writeln('check');
					Counter := 1;
					pX := List.pHead;
					while pX <> nil do begin
						PrintState(pX^.mState, 30, 1, 255);
						GotoXY(30, 10);
						Write('move number: ', Counter);
						CH := ReadKey;
						if CH = #13 then begin
							Counter := Counter + 1;
							pX := pX^.pNext;
						end else break;
					end;
					PrintState(State, 1, 1, 255);
					GotoXY(1, 10);
					Write('press any key to continue');
					
				end;
				List.Free;
			end;
		end;
		ReadKey;
		TextBackground(0);
		TextColor(7);
		ClrScr;
		GotoXY(1, 10);
	end;
	procedure RunPseudoAnalyzer(Colour: Byte);
	var	King: array[0..1] of Byte;
		Name: array[0..1] of string[5];
		List: TList;
		Counter: LongInt;
		pX:      PCell;
		CH:      Char;
	begin
		GotoXY(1, 10);
		if not IsPseudoLegal(State) then begin
			Writeln('illegal position');
			Writeln('press any key to continue');
		end else begin
			King[0] := State.BK; Name[0] := 'black';
			King[1] := State.WK; Name[1] := 'white';
			PrintState(State, 1, 1, Colour);
			Writeln(Name[Colour], ' on move');
			if not IsLegal(State, 1-Colour) then
				Writeln('illegal position for ', Name[1-Colour])
			else begin
				List.Init;
				PseudoGenerator(List, State, Colour);
				if not List.IsEmpty then begin
					Counter := 1;
					pX := List.pHead;
					while pX <> nil do begin
						PrintState(pX^.mState, 30, 1, 255);
						GotoXY(30, 10);
						Write('pseudo move number: ', Counter);
						CH := ReadKey;
						if CH = #13 then begin
							Counter := Counter + 1;
							pX := pX^.pNext;
						end else break;
					end;
					PrintState(State, 1, 1, 255);
					GotoXY(1, 10);
					Write('press any key to continue');
					
				end;
				List.Free;
			end;
		end;
		ReadKey;
		TextBackground(0);
		TextColor(7);
		ClrScr;
		GotoXY(1, 10);
	end;
	procedure RunSymetry;
	var	Index:   LongInt;
		Epsilon: Byte;
	begin
		GotoXY(1, 10);
		if not IsPseudoLegal(State) then
			Writeln('illegal position')
		else begin
			BasicState(State, Epsilon);
			if State.WQ <> 255 then begin
				Index := Convert(State);
				GotoXY(30, 11); Write('state index: ', Index);
				if STRATEGYCheck then begin
					GotoXY(30, 12); Write('white strategy: ', STRATEGY[1, Index]);
					GotoXY(30, 13); Write('black strategy: ', STRATEGY[0, Index]);
				end;
			end;
			PrintState(State, 30, 1, 255);
			OriginalState(State, Epsilon);
			PrintState(State, 1, 1, 255);
			GotoXY(1, 10);
			Write('original state');
			GotoXY(30, 10);
			Write('basic state + epsilon = ', Epsilon);
		end;
		GotoXY(1, 11);
		Write('press any key to continue');
		ReadKey;
		TextBackground(0);
		TextColor(7);
		ClrScr;
	end;
	procedure RunInvConvert;
	var 	PseudoState: TState;
		Index: LongInt;
	begin
		PseudoState.WK := 255;
		PseudoState.BK := 255;
		PseudoState.WQ := 255;
		PseudoState.BR := 255;
		TextBackground(0);
		TextColor(7);
		ClrScr;
		while true do begin
			PrintState(PseudoState, 1, 1, 255);
			GotoXY(1, 11); Write(BlankLine);
			GotoXY(1, 11); Write('enter index (0..', RangeKQKR - 1, '), -1 to exit or -2 to save and exit: ');
			Readln(Index);
			if Index = -1 then break
			else if Index = -2 then begin
				if IsPseudoLegal(PseudoState) then begin
					State := PseudoState;
					break;
				end;
			end else if (Index < - 1) or (Index > RangeKQKR - 1) then begin
				GotoXY(1, 12); Write(BlankLine);
				GotoXY(1, 12); Write('illegal index');
				GotoXY(1, 13); Write(BlankLine);
				GotoXY(1, 14); Write(BlankLine);
				GotoXY(1, 15); Write(BlankLine);
				GotoXY(1, 16); Write(BlankLine);
				PseudoState.WK := 255;
				PseudoState.BK := 255;
				PseudoState.WQ := 255;
				PseudoState.BR := 255;
			end else begin
				PseudoState := InvConvert(Index);
				GotoXY(1, 13);	
				if PseudoState.WK <> 255 then Writeln('White king:  ', Chr(Col(PseudoState.WK)+Ord('A')), Row(PseudoState.WK) + 1);
				if PseudoState.BK <> 255 then Writeln('Black king:  ', Chr(Col(PseudoState.BK)+Ord('A')), Row(PseudoState.BK) + 1);
				if PseudoState.WQ <> 255 then Writeln('White queen: ', Chr(Col(PseudoState.WQ)+Ord('A')), Row(PseudoState.WQ) + 1);
				if PseudoState.BR <> 255 then Writeln('Black rook:  ', Chr(Col(PseudoState.BR)+Ord('A')), Row(PseudoState.BR) + 1);
				if IsPseudoLegal(PseudoState) then begin
					GotoXY(1, 12); Write('pseudolegal position');
				end else begin
					GotoXY(1, 12); Write('illegal position    ');
					PseudoState.WK := 255;
					PseudoState.BK := 255;
					PseudoState.WQ := 255;
					PseudoState.BR := 255;
				end;
			end;
		end;
		TextBackground(0);
		TextColor(7);
		ClrScr;
	end;
	procedure RunSTRATEGYAnalyzer;
		procedure PrintIndex(Index: LongInt);
		var	PseudoState: TState;
		begin
			TextBackground(0);
			TextColor(7);
			ClrScr;
			PseudoState := InvConvert(Index);
			PrintState(PseudoState, 1, 1, 255);
			GotoXY(1, 10); Write('position: '); PrintStatePosition(PseudoState);
			GotoXY(1, 11); Write('index:    ', Index);
			GotoXY(1, 12); Write('press any key to continue');
			ReadKey;
			TextBackground(0);
			TextColor(7);
			ClrScr;
		end;
	var	Index: LongInt;
		Count: LongInt;
		Stat : array[Byte] of LongInt;
		WhiteUndefined: LongInt;
		BlackUndefined: LongInt;
		WhiteUndefinedLegal: LongInt;
		BlackUndefinedLegal: LongInt;
		PseudoState: TState;
		Position: Byte;
		I, MaxI: Byte;
	begin
		if not STRATEGYCheck then Exit;
		TextBackground(0);
		TextColor(7);
		ClrScr;
		GotoXY(1, 1);
		Write('generating strategy statistics, please wait');
		for I := 0 to 255 do
			Stat[I] := 0;
		WhiteUndefined := 0;
		BlackUndefined := 0;
		WhiteUndefinedLegal := 0;
		BlackUndefinedLegal := 0;
		for Index := 0 to RangeKQKR - 1 do begin
			PseudoState := InvConvert(Index);
			if STRATEGY[0, Index] = 255 then begin
				BlackUndefined := BlackUndefined + 1;
				if IsLegal(PseudoState, 0) then
					BlackUndefinedLegal := BlackUndefinedLegal + 1;
			end else Inc(Stat[STRATEGY[0, Index]]);
			if STRATEGY[1, Index] = 255 then begin
				WhiteUndefined := WhiteUndefined + 1;
				if IsLegal(PseudoState, 1) then
					WhiteUndefinedLegal := WhiteUndefinedLegal + 1;	
			end else Inc(Stat[STRATEGY[1, Index]]);
		end;
		for MaxI := 255 downto 0 do
			if Stat[MaxI] <> 0 then break;
		while True do begin
			TextBackground(0);
			TextColor(7);
			ClrScr;
			GotoXY(1,  1); Write('strategy statistics:');
			GotoXY(1,  2); Write('black');
			GotoXY(21, 2); Write('white');
			for I := 0 to MaxI do begin
				if I mod 2 = 0 then begin
					GotoXY(1,  I div 2 + 3);
					Write(I:5, ': ', Stat[I]);
				end else begin
					GotoXY(21, I div 2 + 3);
					Write(I:5, ': ', Stat[I]);
				end;
			end;
			Writeln;
			Writeln('white undefined / legal undefined: ', WhiteUndefined, ' / ', WhiteUndefinedLegal);
			Writeln('black undefined / legal undefined: ', BlackUndefined, ' / ', BlackUndefinedLegal);
			Writeln;
			Writeln('enter 0..', MaxI, ' for defined, -1 to exit');
			Writeln('254 for black undefined, 255 for white undefined');
			Write('command: '); Readln(Index);
			if Index = -1 then break
			else if (Index >= 0) and (Index <= MaxI) then begin
				Position := Index;
				I := Position mod 2;
				while True do begin
					Write('enter index 1..', Stat[Position], ': '); Readln(Count);
					if (Count >= 1) and (Count <= Stat[Position]) then break
					else Writeln('bad index');
				end;
				for Index := 0 to RangeKQKR - 1 do begin
					if STRATEGY[I, Index] = Position then
						Count := Count - 1;
					if Count = 0 then break;
				end;
				PrintIndex(Index);
			end else if Index = 254 then begin
				while True do begin
					Write('enter index 1..', BlackUndefinedLegal, ': '); Readln(Count);
					if (Count >= 1) and (Count <= BlackUndefinedLegal) then break
					else Writeln('bad index');
				end;	
				for Index := 0 to RangeKQKR - 1 do begin
					PseudoState := InvConvert(Index);
					if (STRATEGY[0, Index] = 255) and
					   (IsLegal(PseudoState, 0)) then
						Count := Count - 1;
					if Count = 0 then break;
				end;
				PrintIndex(Index);
			end else if Index = 255 then begin
				while True do begin
					Write('enter index 1..', WhiteUndefinedLegal, ': '); Readln(Count);
					if (Count >= 1) and (Count <= WhiteUndefinedLegal) then break
					else Writeln('bad index');
				end;
				for Index := 0 to RangeKQKR - 1 do begin
					PseudoState := InvConvert(Index);
					if (STRATEGY[1, Index] = 255) and
					   (IsLegal(PseudoState, 1)) then
						Count := Count - 1;
					if Count = 0 then break;
				end;
				PrintIndex(Index);
			end else begin
				Writeln('bad command');
				Writeln('press any key to continue');
				ReadKey;
			end;
		end;
		TextBackground(0);
		TextColor(7);
		ClrScr;
	end;
	procedure RunPositionAnalyzer;
	var	Index: LongInt;
		List: TList;
		pX  : PCell;
	begin
		if not STRATEGYCheck then Exit;
		
		TextBackground(0);
		TextColor(7);
		ClrScr;
		
		PrintState(State, 1, 1, 255);
		GotoXY(1, 10);

		if not (IsPseudoLegal(State)) or
		       (State.WQ = 255) then begin
			Writeln('illegal position');
			Writeln('press any key to continue');
		end else begin
			Index := GetIndex(State);
			Writeln('white: ', STRATEGY[1, Index]);
			Writeln('black: ', STRATEGY[0, Index]);
			Writeln('white moves: ');
			List.Init;
			OptimalMove(List, State, 1);
			pX := List.pHead;
			while pX <> nil do begin
				PrintStatePosition(pX^.mState);
				Writeln;
				pX := pX^.pNext;
			end;
			List.Free;
			Writeln('black moves: ');
			List.Init;
			OptimalMove(List, State, 0);
			pX := List.pHead;
			while pX <> nil do begin
				PrintStatePosition(pX^.mState);
				Writeln;
				pX := pX^.pNext;
			end;
			List.Free;
		end;
		
		ReadKey;
		TextBackground(0);
		TextColor(7);
		ClrScr;
	end;
	procedure RunBruteForce;
	var 	WK, BK, WQ, BR: Byte;
		PseudoState: TState;
		TestState  : TState;
		Index, Yndex: LongInt;
		Value, Ualue: Byte;      
		OldState, NewState: TState;
		OldIndex, NewIndex: LongInt;
		List: TList;
		pX  : PCell;
		Count,
		CountPseudoLegal,
		CountWhiteLegal,
		CountBlackLegal,
		CountWhiteCheckmate,
		CountBlackCheckmate,
		CountWhiteStalemate,
		CountBlackStalemate: LongInt;
		Epsilon: Byte;
		Check       : Boolean;
		ErrorOccured: Boolean;
	begin
		TextBackground(0);
		TextColor(7);
		ClrScr;
		GotoXY(1, 1);
		Writeln('this operation can take several minutes');
		Writeln('press ENTER to continue');
		if ReadKey = #13 then begin
			ClrScr;
			GotoXY(1, 1);
			ErrorOccured := False;
			Write('testing symetry   ');
			for WK := 0 to 63 do begin
				if WK mod 2 = 0 then Write('.');
				for BK := 0 to 63 do begin
					for WQ := 0 to 64 do begin
						for BR := 0 to 64 do begin
							PseudoState.WK := InvOffsetC[WK];
							PseudoState.BK := InvOffsetC[BK];
							PseudoState.WQ := InvOffsetC[WQ];
							PseudoState.BR := InvOffsetC[BR];
							Count := 0;
							TestState := PseudoState;
							if IsBasicState(TestState) then begin
								NewState := TestState;
								Count := 1;
							end;
							TestState := PseudoState; SymState(TestState, 0);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							TestState := PseudoState; SymState(TestState, 1);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							TestState := PseudoState; SymState(TestState, 2);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							TestState := PseudoState; SymState(TestState, 3);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							TestState := PseudoState; SymState(TestState, 0); SymState(TestState, 1);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							TestState := PseudoState; SymState(TestState, 0); SymState(TestState, 2);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							TestState := PseudoState; SymState(TestState, 0); SymState(TestState, 3);
							if IsBasicState(TestState) then begin
								if Count = 0 then begin
									NewState := TestState; Count := 1;
								end else if Count = 1 then begin
									if (TestState.WK <> NewState.WK) or (TestState.BK <> NewState.BK) or
									   (TestState.WQ <> NewState.WQ) or (TestState.BR <> NewState.BR) then
										Count := 2;
								end;
							end;
							if Count <> 1 then begin
								PrintStatePosition(TestState);
								ErrorOccured := True;
								break;
							end;
							OldState := PseudoState;
							NewState := PseudoState;
							BasicState(NewState, Epsilon);
							if not IsBasicState(NewState) then begin
								ErrorOccured := True;
								break;
							end;
							OriginalState(NewState, Epsilon);
							if (OldState.WK <> NewState.WK) or
							   (OldState.BK <> NewState.BK) or
							   (OldState.WQ <> NewState.WQ) or
							   (OldState.BR <> NewState.BR) then begin
							   	ErrorOccured := True;
								break;
							end;
						end;
						if ErrorOccured then break;
					end;
					if ErrorOccured then break;
				end;
				if ErrorOccured then break;
			end;
			if ErrorOccured then Writeln(' failed')
			else Writeln(' passed');
			ErrorOccured := False;
			CountPseudoLegal := 0;
			CountWhiteLegal := 0;
			CountBlackLegal := 0;
			CountWhiteCheckmate := 0;
			CountBlackCheckmate := 0;
			CountWhiteStalemate := 0;
			CountBlackStalemate := 0;
			Write('testing converter ');
			for OldIndex := 0 to RangeKQKR - 1 do begin
				if OldIndex mod (RangeKQKR div 32) = 0 then Write('.');
				PseudoState := InvConvert(OldIndex);
				NewIndex := Convert(PseudoState);
				if (not IsBasicState(PseudoState)) or
				   (OldIndex <> NewIndex) then begin
					ErrorOccured := True;
					break;
				end;
				if IsPseudoLegal(PseudoState) then begin
					CountPseudoLegal := CountPseudoLegal + 1;
					if IsLegal(PseudoState, 1) then begin
						CountWhiteLegal := CountWhiteLegal + 1;
						List.Init;
						Generator(List, PseudoState, 1);
						if List.IsEmpty then begin
							if IsAttacked(PseudoState.WK, PseudoState, 0) then
								CountWhiteCheckmate := CountWhiteCheckmate + 1
							else	CountWhiteStalemate := CountWhiteStalemate + 1;
						end;
						List.Free;
					end;
					if IsLegal(PseudoState, 0) then begin
						CountBlackLegal := CountBlackLegal + 1;
						List.Init;
						Generator(List, PseudoState, 0);
						if List.IsEmpty then begin
							if IsAttacked(PseudoState.BK, PseudoState, 1) then
								CountBlackCheckmate := CountBlackCheckmate + 1
							else	CountBlackStalemate := CountBlackStalemate + 1;
						end;
						List.Free;
					end;
				end;
			end;
			if ErrorOccured then Writeln(' failed')
			else begin
				Writeln(' passed');
				Writeln('statistics (only for positions KQ+K and KQ+KR in basic state):');
				Writeln('all positions         : ', RangeKQKR);
				Writeln('pseudolegal positions : ', CountPseudoLegal);
				Writeln('white can move        : ', CountWhiteLegal);
				Writeln('white checkmate       : ', CountWhiteCheckmate);
				Writeln('white stalemate       : ', CountWhiteStalemate);
				Writeln('black can move        : ', CountBlackLegal);
				Writeln('black checkmate       : ', CountBlackCheckmate);
				Writeln('black stalemate       : ', CountBlackStalemate);
			end; 
			ErrorOccured := False;
			if STRATEGYCheck then begin
				Write('testing strategy  ');
				for Index := 0 to RangeKQKR - 1 do begin
					if Index mod (RangeKQKR div 32) = 0 then Write('.');
					PseudoState := InvConvert(Index);
					if IsLegal(PseudoState, 0) then begin
						Value := STRATEGY[0, Index];
						if (Value >= 2) and (Value <> 255) then begin
							List.Init;
							Generator(List, PseudoState, 0);
							pX := List.pHead;
							Check := False;
							while pX <> nil do begin
								Yndex := GetIndex(pX^.mState);
								Ualue := STRATEGY[1, Yndex];
								if Ualue > Value then begin
									ErrorOccured := True;
									break;
								end;
								if Ualue = Value - 1 then
								       Check := True;	
								pX := pX^.pNext;
							end;
							if not Check then
								ErrorOccured := True;
							List.Free;
						end;
					end;
					if ErrorOccured then break;
					if IsLegal(PseudoState, 1) then begin
						Value := STRATEGY[1, Index];
						if (Value <> 255) then begin
							List.Init;
							Generator(List, PseudoState, 1);
							pX := List.pHead;
							Check := False;
							while pX <> nil do begin
								Yndex := GetIndex(pX^.mState);
								Ualue := STRATEGY[0, Yndex];
								if Ualue < Value - 1 then begin
									ErrorOccured := True;
									break;
								end;
								if Ualue = Value - 1 then
									Check := True;
								pX := pX^.pNext;
							end;
							if not Check then
								ErrorOccured := True;
							List.Free;
						end;
					end;
					if ErrorOccured then break;
				end;
				if ErrorOccured then Writeln(' failed')
				else Writeln(' passed');
			end;
		end;
		Writeln('press any key to continue');
		TextBackground(0);
		TextColor(7);
		ReadKey;
		ClrScr;
	end;
	procedure RunSTRATEGYGenerator;
	var	CH: Char;
	begin
		TextBackground(0);
		TextColor(7);
		ClrScr;
		if FileExist('strategy.dat') then begin
			Writeln('file strategy.dat found');
			Writeln('a) load strategy');
			Writeln('b) rebuild strategy');
			Writeln('other) leave this menu');
			CH := ReadKey;
			case Upcase(CH) of
				'A': begin
					Write('loading strategy.dat: ');
					if LoadSTRATEGY then Writeln(' success')
					else Writeln(' loading failed');
				     end;
				'B': begin
					Writeln('generating strategy - this can take a long time');
					STRATEGYGenerator;
				     end;
			end;
		end else begin
			Writeln('generating strategy - this can take a long time');
			STRATEGYGenerator;
		end;
		Writeln('press any key to continue');
		ReadKey;
		TextBackground(0);
		TextColor(7);
		ClrScr;
	end;
var
	CH: Char;
begin
	TextBackground(0);
	TextColor(7);
	ClrScr;
	
	State.WK := 255;
	State.BK := 255;
	State.WQ := 255;
	State.BR := 255;

	repeat
		PrintState(State, 1, 1, 255);
		GotoXY(1, 13);
		Writeln('ESC   - exit tester / moves');
		Writeln('ENTER - set position');
		Writeln('1     - white moves');
		Writeln('2     - black moves');
		Writeln('3     - white pseudomoves');
		Writeln('4     - black pseudomoves');
		Writeln('5     - symetry + convert');
		Writeln('6     - inv convert');
		if STRATEGYCheck then begin
		Writeln('7     - strategy analyzer');
		Writeln('8     - position analyzer');
		end;
		Writeln('9     - brute force testing');
		Writeln('0     - strategy generator');
		Writeln;
		if STRATEGYCheck then begin
		Writeln('        strategy is loaded');
		end;
		GotoXY(1, 10);
		CH := ReadKey;
		if CH = #13 then RunParser
		else if CH = '1' then RunAnalyzer(1)
		else if CH = '2' then RunAnalyzer(0)
		else if CH = '3' then RunPseudoAnalyzer(1)
		else if CH = '4' then RunPseudoAnalyzer(0)
		else if CH = '5' then RunSymetry
		else if CH = '6' then RunInvConvert
		else if CH = '7' then RunSTRATEGYAnalyzer
		else if CH = '8' then RunPositionAnalyzer
		else if CH = '9' then RunBruteForce
		else if CH = '0' then RunSTRATEGYGenerator;
	until CH = #27;
	
	NormVideo;
	ClrScr;
end;
var	Cheat: Boolean;
procedure Game;
const	BlankLine: string = '                                                                      ';
var	Stat   : array[Byte] of LongInt;
	State  : TState;
	Check  : Byte;
	Colour : Byte;
	BlackI,
	WhiteI : Byte;
	MoveList: TList;
	procedure SetCheck(C: Byte);
	var	King: array[0..1] of Byte;
		List: TList;
	begin
		King[0] := State.BK;
		King[1] := State.WK;
		List.Init;
		Generator(List, State, C);
		if List.IsEmpty then begin
			if IsAttacked(King[C], State, 1 - C) then Check := 2
			else Check := 3;
		end else begin
			if IsAttacked(King[C], State, 1 - C) then Check := 1
			else Check := 0;
		end;
		List.Free;
	end;
	procedure WriteCheck;
	begin
		if Check = 1 then Write('check')
		else if Check = 2 then Write('checkmate')
		else if Check = 3 then Write('stalemate')
		else if Check = 4 then Write('game over');
	end;
	procedure WriteTodo;
	var	Value: Byte;
	begin
		Value := GetSTRATEGYValue(State, Colour);
		if (Value < 255) and (Check < 2) then
			Write('todo: ', (Value + 1) div 2);
	end;
	procedure PrintMoveList;
	var	pX, pY: PCell;
		Count: LongInt;
		Shift : Byte;
		Bottom: Byte;
	begin
		Count := MoveList.Count;
		if Count >= 8 then Bottom := 8
		else Bottom := Count;
		for Shift := 1 to 8 do begin
			GotoXY(27, Shift);
			Write('                        ');
		end;
		Shift := 0;
		pX := MoveList.pHead;
		pY := pX^.pNext;
		while pY <> nil do begin
			if Shift = Bottom then break;
			GotoXY(27, Bottom - Shift);
			Write((Count - Shift - 1):4, ': ', MoveToStr(pY^.mState, pX^.mState));
			pX := pY;
			pY := pY^.pNext;
			Shift := Shift + 1;
		end;
		if Shift < Bottom then begin
			GotoXY(27, 1);
			Write('WK BK WQ BR = '); PrintStatePosition(pX^.mState);
		end;
	end;
	procedure RunNewGame;
	var	Index   : LongInt;
		Count   : LongInt;
		Position: Byte;
		CH: Char;
	begin
		TextBackground(0);
		TextColor(15);
		ClrScr;
		Writeln('select your colour:');
		Writeln('w = white');
		Writeln('b = black');
		repeat
			CH := UpCase(ReadKey);
			     if CH = 'B' then begin Colour := 0; break; end
			else if CH = 'W' then begin Colour := 1; break; end
			else Writeln('please, press w or b');
		until False;
		if Colour = 0 then Position := BlackI
		else Position := WhiteI;
		Count := Random(Stat[Position]) + 1;
		for Index := 0 to RangeKQKR - 1 do begin
			if STRATEGY[Colour, Index] = Position then
				Count := Count - 1;
			if Count = 0 then break;
		end;
		State := InvConvert(Index);
		OriginalState(State, Random(8));
		SetCheck(Colour);
		MoveList.Free;
		MoveList.AddState(State);
		TextBackground(0);
		TextColor(15);
		ClrScr;
	end;
	procedure RunPlay;
	var	Command: string[50];
		FromState, ToState: TState;
		List: TList;
		pX  : PCell;
		Count: LongInt;
		ShowTodo: Boolean;
	begin
		ShowTodo := False;
		TextBackground(0);
		TextColor(15);
		ClrScr;
		repeat
			TextBackground(0);
			TextColor(15);
			GotoXY(1, 14);
			Writeln('new  - new game');
			if Cheat then begin
				TextColor(14);
				Writeln('back - move back');
				Writeln('hint - computer help');
				if ShowTodo then
					Writeln('todo - hide remaining moves')
				else	Writeln('todo - show remaining moves');
				TextColor(15);
			end;
			Writeln('exit - exit this program');
			PrintMoveList;
			PrintState(State, 1, 1, 255);
			TextColor(15);
			GotoXY(1, 10); Write(BlankLine);
			GotoXY(1, 11); Write(BlankLine);
			GotoXY(27, 9); Write('         ');
			GotoXY(1, 10); WriteCheck;
			if Cheat then begin
				TextColor(14);
				GotoXY(27, 9);
				if ShowTodo then
					WriteTodo;
				TextColor(15);
			end;
			GotoXY(1, 11); 
			if Colour = 0 then
				Write('black command: ')
			else	Write('white command: ');
			Readln(Command);
			GotoXY(1, 12); Write(BlankLine);
			if Command = 'new' then RunNewGame
			else if (Cheat) and (Command = 'back') and (MoveList.Count > 1) then begin
				if MoveList.Count mod 2 = 1 then begin
					MoveList.Pop;
					MoveList.Pop;
				end else
					MoveList.Pop;
				State := MoveList.pHead^.mState;
				SetCheck(Colour);	
			end else if (Cheat) and (Command = 'hint') and (Check < 2) then begin
				List.Init;
				OptimalMove(List, State, Colour);
				GotoXY(1, 12); Write(BlankLine);
				TextColor(14);
				GotoXY(1, 12);
				Count := 5;
				pX := List.pHead;
				while (pX <> nil) and (Count > 0) do begin
					Write(MoveToStr(State, pX^.mState), ' ');
					pX := pX^.pNext;
					Count := Count - 1;
				end;
				TextColor(15);
				List.Free;
			end else if (Cheat) and (Command = 'todo') then begin
				ShowTodo := not ShowTodo;
			end else if Command = 'exit' then break
			else if (Check = 0) or (Check = 1) then begin
				FromState := State;
				if StrToMove(ToState, FromState, Colour, Command) then begin
					MoveList.AddState(ToState);
					State := ToState;
					SetCheck(1 - Colour);
					PrintState(State, 1, 1, 255);
					if Check < 2 then begin
						List.Init;
						OptimalMove(List, State, 1 - Colour);
						if not List.IsEmpty then begin
							Count := Random(List.Count);
							pX := List.pHead;
							while Count > 0 do begin
								pX := pX^.pNext;
								Count := Count - 1;
							end;
							FromState := State;
							ToState   := pX^.mState;
							State     := ToState;
							SetCheck(Colour);
							MoveList.AddState(ToState);
							Delay(100);
							PrintState(State, 1, 1, 255);
							TextColor(7);
							GotoXY(1, 12); Write('computer move: ', MoveToStr(FromState, ToState));
						end else Check := 4;
						List.Free;
					end;
				end;
			end;
		until False;
		TextBackground(0);
		TextColor(15);
		ClrScr;
	end;
var 	Index  : LongInt;
	I, MaxI: Byte;
	CH     : Char;
begin
	TextBackground(0);
	TextColor(7);
	ClrScr;
	GotoXY(1, 1);
	Writeln('Welcome to King + Queen VS King + Rook endgame');
	if FileExist('strategy.dat') then begin
		Writeln('file strategy.dat found');
		Write  ('loading strategy.dat: ');
		if LoadSTRATEGY then Writeln(' success')
				else Writeln(' loading failed');
	end else begin
		Writeln('file strategy.dat does not exist');
		Writeln('you have to create it to play this endgame');
		Writeln('this operation can take a long time');
		Writeln('do you want to create it? (y/n)');
		repeat
			CH := UpCase(ReadKey);
			     if CH = 'Y' then begin STRATEGYGenerator; break; end
			else if CH = 'N' then begin Writeln('ok');     break; end
			else Writeln('please, press y or n');
		until False;
	end;
	if STRATEGYCheck then begin
		Write('generating strategy statistics, please wait: ');
		for I := 0 to 255 do
			Stat[I] := 0;
		for Index := 0 to RangeKQKR - 1 do begin
			if STRATEGY[0, Index] <> 255 then Inc(Stat[STRATEGY[0, Index]]);
			if STRATEGY[1, Index] <> 255 then Inc(Stat[STRATEGY[1, Index]]);
		end;
		for MaxI := 255 downto 0 do
			if Stat[MaxI] <> 0 then break;
		if MaxI mod 2 = 0 then begin
			BlackI := MaxI;
			WhiteI := MaxI - 1;
		end else begin
			WhiteI := MaxI;
			BlackI := MaxI - 1;
		end;
		Writeln('success');
		Delay(500);
		MoveList.Init;
		RunNewGame;
		RunPlay;
		MoveList.Free;
	end;

	NormVideo;
	ClrScr;
end;
begin
	InitVariables;
	Cheat := False;
	if ParamCount = 1 then begin
		if (ParamStr(1) = '-d') or
		   (ParamStr(1) = '-D') then Tester
		else if ParamStr(1) = '-cheat' then begin
			Cheat := True;
			Game;
		end;
	end else Game;
end.
